<?php
function getFieldLabel_AuthHelper($field, array $fieldRules, array $attributes = array()): string
{
  switch ($field) {
    default:
      if (strpos($fieldRules[$field], 'required') !== false) {
        array_push($attributes, 'style="color:red";');
      }
      return sprintf("<span %s>%s</span>", implode(" ", $attributes), lang("Admin/Cloudflare/API/Auth.label.{$field}"));
      break;
  }
}

//header.php에서 getFieldForm_Helper사용
function getFieldForm_AuthHelper($field, $value, array $formOptions, array $attributes = array())
{
  $value = is_null($value) ? DEFAULT_EMPTY : $value;
  switch ($field) {
    case 'uid':
      $attributes['id'] = "uid_select";
      return sprintf(
        "%s %s",
        form_dropdown($field, $formOptions[$field], $value, $attributes),
        '<button id="selectKey" type="button" class="btn btn-info btn-circle fa fa-refresh">Auth선택</button>'
      );
      break;
    case 'status':
      return form_dropdown($field, $formOptions[$field], $value, $attributes);
      break;
    case 'updated_at':
    case 'created_at':
      $attributes["class"] = !array_key_exists("class", $attributes) ? "calender" : $attributes["class"] . " calender";
      return form_input($field, $value, $attributes);
      break;
    default:
      return form_input($field, $value, $attributes);
      break;
  }
} //

function getFieldView_AuthHelper($field, $entity, array $fieldFilters, $fieldFormOptions, $attributes = array())
{
  switch ($field) {
    default:
      if (in_array($field, $fieldFilters)) {
        return $fieldFormOptions[$field][$entity->$field];
      }
      return $entity->$field;
      break;
  }
} //

function getFieldIndex_Column_AuthHelper($field, $order_field, $order_value, array $attributes = array())
{
  $label = lang("Admin/Cloudflare/API/Auth.label.{$field}");
  $label = $field == $order_field ? sprintf('%s <i class="fa fa-arrow-%s"></i>', $label, $order_value == 'ASC' ? "up" : "down") : $label;
  $order_value = $order_value == 'DESC' ? "ASC" : "DESC";
  return anchor(current_url() . "?order_field={$field}&order_value={$order_value}", $label, $attributes);
} //

function getFieldIndex_Row_AuthHelper($field, array $row, array $fieldFilters, array $fieldFormOptions, array $attributes = array()): string
{
  switch ($field) {
    case 'id':
      return sprintf(
        '<div style="text-align:left; padding-left:30px;">%s %s %s</div>',
        anchor(base_url() . '/admin/cloudflare/auth/reload/' . $row['uid'], ' ', ["class" => "btn btn-sm btn-primary btn-circle fa fa-refresh", "target" => "_self"]),
        anchor(base_url() . '/admin/cloudflare/account?auth_uid=' . $row['uid'], ' ', ["class" => "btn btn-sm btn-primary btn-circle fa fa-flag", "target" => "_self"]),
        anchor(current_url() . '/view/' . $row['uid'], $row[$field], ["target" => "_self"]),
      );
      break;
    case 'updated_at':
    case 'created_at':
      return str_split($row[$field], 10)[0];
      break;
    default:
      if (in_array($field, $fieldFilters)) {
        $attributes["onChange"] = sprintf('location.href="%s/toggle/%s/%s?%s="+this.options[this.selectedIndex].value', current_url(), $row['uid'], $field, $field);
        return getFieldForm_AuthHelper($field, $row[$field], $fieldFormOptions, $attributes);
      }
      return $row[$field];
      break;
  }
} //